%define _libexecdir %{_exec_prefix}/lib
%define lprob linux-boot-prober

Name:           os-prober
Version:        1.63
Release:        4
Summary:        Probes disks on the system for installed operating systems
License:        GPLv1 and GPLv2+
Group:          System/Configuration/Boot and Init
Url:            http://kitenet.net/~joey/code/os-prober/
#               http://ftp.de.debian.org/debian/pool/main/o/os-prober/os-prober_1.61.tar.gz
Source0:        http://ftp.de.debian.org/debian/pool/main/o/%{name}/%{name}_%{version}.tar.gz
Source1:        COPYING-note.txt

# move newns binary outside of os-prober subdirectory, so that debuginfo
# can be automatically generated for it
Patch0:         os-prober-newnsdirfix.patch
# Fix spelling of SUSE aj@suse.de
Patch1:         os-prober-SUSE.patch
# Sent upstream by Fedora
Patch2:         os-prober-mdraidfix.patch
Patch3:         os-prober-yaboot-parsefix.patch
Patch4:         os-prober-usrmovefix.patch
Patch5:         os-prober-remove-basename.patch
Patch6:         os-prober-disable-debug-test.patch
# To be sent upstream by Fedora
Patch7:         os-prober-btrfsfix.patch
Patch8:         os-prober-factor-out-logger.patch
Patch9:         os-prober-bootpart-name-fix.patch
Patch10:        os-prober-mounted-partitions-fix.patch
# Add ROSA to 90linux-distro
Patch11:        os-prober-1.57-add_rosa-release_to_90linux-distro.patch
#Patch12:		os-prober-missed-os-fix.patch

Patch13:        os-prober-1.63-fallback-sort-by-kernel-version.patch
Patch14:        os-prober-1.63-skip-os-prober-entries.patch
Patch15:        os-prober-1.63-efi-support.patch

%description
This package detects other OSes available on a system and outputs the results
in a generic machine-readable format. Support for new OSes and Linux
distributions can be added easily.

%prep
%setup -q -n %{name}-%{version}
cp %SOURCE1 .

%apply_patches

%build

%make

%install
install -m 0755 -d %{buildroot}%{_bindir}
install -m 0755 -d %{buildroot}%{_sbindir}
install -m 0755 -d %{buildroot}%{_localstatedir}/lib/%{name}

install -m 0755 -p os-prober linux-boot-prober %{buildroot}%{_sbindir}
install -m 0755 -Dp newns %{buildroot}%{_libexecdir}/newns
install -m 0644 -Dp common.sh %{buildroot}%{_datadir}/%{name}/common.sh

%ifarch %{ix86} x86_64
ARCH=x86
%endif

for probes in os-probes os-probes/mounted os-probes/init \
              linux-boot-probes linux-boot-probes/mounted; do
        install -m 755 -d %{buildroot}%{_libexecdir}/$probes
        cp -a $probes/common/* %{buildroot}%{_libexecdir}/$probes
        if [ -e "$probes/$ARCH" ]; then
                cp -a $probes/$ARCH/* %{buildroot}%{_libexecdir}/$probes
        fi
done
if [ "$ARCH" = x86 ]; then
        install -m 755 -p os-probes/mounted/powerpc/20macosx \
            %{buildroot}%{_libexecdir}/os-probes/mounted
fi

# console user, ask for root password
for pak in %{name} %{lprob}; do
        ln -s %{_bindir}/consolehelper %{buildroot}%{_bindir}/$pak
        mkdir -p %{buildroot}%{_sysconfdir}/security/console.apps
        cat > %{buildroot}%{_sysconfdir}/security/console.apps/$pak <<EOF
USER=root
PROGRAM=/usr/sbin/$pak
FALLBACK=false
SESSION=true
EOF
        mkdir -p %{buildroot}%{_sysconfdir}/pam.d
		cat > %{buildroot}%{_sysconfdir}/pam.d/$pak  <<EOF
#%PAM-1.0
auth		include		config-util
account		include		config-util
session		include		config-util
EOF
done

%files
%doc README TODO debian/copyright debian/changelog COPYING-note.txt
%{_bindir}/*
%{_sbindir}/*
%{_libexecdir}/linux-boot-probes
%{_libexecdir}/newns
%{_libexecdir}/os-probes
%{_datadir}/%{name}
%{_localstatedir}/lib/%{name}
%{_sysconfdir}/pam.d/*
%{_sysconfdir}/security/console.apps/*

%changelog
* Fri Jul 18 2014 Konstantin Vlasov <konstantin.vlasov@rosalab.ru> 1.63-4
+ Revision: 5deec92
- Improvements in boot entries enumerating
- 1. Sorting by kernels (latest first) when enumerating boot entries.
- 2. When parsing grub2 menu, skip entries generated by 30_os-prober: they do not belong to the analyzed system.
- 3. Grub2 menu parser: Added support for EFI menu entries.


